回溯的题
47. 全排列 II
给定一个可包含重复数字的序列 nums ,按任意顺序 返回所有不重复的全排列。
示例 1:
输入:nums = [1,1,2]
输出:
[[1,1,2],
[1,2,1],
[2,1,1]]
示例 2:
输入:nums = [1,2,3]
输出:[[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/permutations-ii
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
解题思路及方法
回溯的方法,需要注意的是题目中有相同的数字,我的解法很垃圾,用一个Set来记录已访过的节点,这样可以避免重复。
class Solution {
List<List<Integer>> res = new LinkedList<>();
public List<List<Integer>> permuteUnique(int[] nums) {
LinkedList<Integer> trace = new LinkedList<>();
Set<Integer> visited = new HashSet<>();
backTrace(nums, trace, visited);
return res;
}
public void backTrace(int[] nums, LinkedList<Integer> trace, Set<Integer> visited) {
if (trace.size() == nums.length) {
List<Integer> tmp = new LinkedList<>(trace);
if (!res.contains(tmp)) res.add(tmp);
return;
}
for (int i = 0; i < nums.length; i++) {
if (visited.contains(i)) continue;
// 做选择
trace.add(nums[i]);
// 添加访问
visited.add(i);
// 进入下一层
backTrace(nums, trace, visited);
// 回溯
trace.removeLast();
visited.remove(i);
}
}
}
结果如下:
39. 组合总和
给定一个无重复元素的正整数数组 candidates 和一个正整数 target ,找出 candidates 中所有可以使数字和为目标数 target 的唯一组合。
candidates 中的数字可以无限制重复被选取。如果至少一个所选数字数量不同,则两种组合是唯一的。
对于给定的输入,保证和为 target 的唯一组合数少于 150 个。
示例 1:
输入: candidates = [2,3,6,7], target = 7
输出: [[7],[2,2,3]]
示例 2:
输入: candidates = [2,3,5], target = 8
输出: [[2,2,2,2],[2,3,3],[3,5]]
示例 3:
输入: candidates = [2], target = 1
输出: []
示例 4:
输入: candidates = [1], target = 1
输出: [[1]]
示例 5:
输入: candidates = [1], target = 2
输出: [[1,1]]
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/combination-sum
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
解题思路及方法
回溯,当当前层的和>=target的时候,记录和等于target的数组,并return。
因为数字可以被无限使用,所以要注意的是会用重复的组合,观察答案,出现的整数都是当前整数和它之后的组合,所以我们只用保证递归的时候是当前数和它之后的数组成的即可。
class Solution {
public List<List<Integer>> res = new LinkedList<>();
public List<List<Integer>> combinationSum(int[] candidates, int target) {
LinkedList<Integer> trace = new LinkedList<>();
backTrace(candidates, target, 0, trace);
return res;
}
public void backTrace(int[] nums, int target, int start, LinkedList<Integer> trace) {
if (getSum(trace) >= target) {
if (getSum(trace) == target) {
res.add(new LinkedList<>(trace));
}
return;
}
for (int i = start; i < nums.length; i++) {
// 做选择
trace.add(nums[i]);
// 进入下一层
backTrace(nums, target, i, trace);
// 回溯
trace.removeLast();
}
}
public int getSum(LinkedList<Integer> list) {
int sum = 0;
for (Integer i : list) {
sum += i;
}
return sum;
}
}
结果如下:
40. 组合总和 II
给定一个数组 candidates 和一个目标数 target ,找出 candidates 中所有可以使数字和为 target 的组合。
candidates 中的每个数字在每个组合中只能使用一次。
注意:解集不能包含重复的组合。
示例 1:
输入: candidates = [10,1,2,7,6,1,5], target = 8,
输出:
[
[1,1,6],
[1,2,5],
[1,7],
[2,6]
]
示例 2:
输入: candidates = [2,5,2,1,2], target = 5,
输出:
[
[1,2,2],
[5]
]
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/combination-sum-ii
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
解题思路及方法
这道题要前一道题复杂一些,因为每个数字只能用一次,而且还会有重复的数字。相比47. 全排列 II,包括 90. 子集 II,对于这种有重复数字的题,首先上来就对nums排序,这样就可以保证所有重复的数字都挨在一起。
紧接上题,组合内部去重的关键在于答案的每一层组合里面都是当前数和当前数之后的数组成,所以用start来协助。然后要保证组合的数字不重复的关键是,if (i > start && nums[i] == nums[i - 1]) continue;这里排序的好处就体现出来了,我们可以保证重复的数字只用一次。
class Solution {
List<List<Integer>> res = new LinkedList<>();
public List<List<Integer>> combinationSum2(int[] candidates, int target) {
LinkedList<Integer> trace = new LinkedList<>();
Arrays.sort(candidates);
backTrace(candidates, target, 0, trace);
return res;
}
public void backTrace(int[] nums, int target, int start, LinkedList<Integer> trace) {
if (target <= 0) {
if (target == 0) res.add(new LinkedList<>(trace));
return;
}
for (int i = start; i < nums.length; i++) {
// 排除已访问项
if (i > start && nums[i] == nums[i - 1]) continue;
// 做选择
trace.add(nums[i]);
// 进入下一层
backTrace(nums, target - nums[i], i + 1, trace);
// 回溯
trace.removeLast();
}
}
}
结果如下: